// <750 Byte Code
package fromHell;

import java.awt.Color;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.util.Arrays;

import robocode.AdvancedRobot;
import robocode.Rules;
import robocode.ScannedRobotEvent;
import robocode.util.Utils;

public class C4H10O extends AdvancedRobot {

    // for movement:
    private final static double PERPENDICULAR = Math.PI / 2.0;
    private final static double MOVE_DISTANCE = 55;
    private final static double WALL_STICK = 160.0;
    private final static double SMOOTH_INC = 0.07;

    private final static double CLOSE_FACTOR = 400;

    private final static double PREFERRED_RANGE = 500;
    private final static double RANDOM_FACTOR = 18;
    private final static double REVERSE_ANGLE = Math.PI / 4.0;

    private final static double REVERSE_CHANCE = 0.6;
    private final static double REVERSE_DIST_ADJ = 150;
    private final static double REVERSE_SUB = 0.02;

    private static double _direction = 1;
    private static double _enemyBulletVelocity = 15.0;

    // for gun:
    static final int BINS = 255;
    static final int PATTERN_DEPTH = 50;

    static StringBuilder _enemyLog = new StringBuilder();
    static double _lastEnemyEnergy;

    public void run() {
	setColors(Color.black, Color.darkGray, Color.lightGray, null, Color.black);
	setAdjustGunForRobotTurn(true);
	setAdjustRadarForGunTurn(true);
	while (true) {
	    turnRadarRightRadians(1);
	}
    }

    public void onScannedRobot(ScannedRobotEvent scannedRobotEvent) {
	double tempDouble, enemyAbsoluteBearing, enemyDistance, smoothedDirection, enemyLateralVelocity, enemyVelocity, bulletPower;

	// radar
	setTurnRadarRightRadians(2.0 * Utils.normalRelativeAngle((tempDouble = enemyAbsoluteBearing = scannedRobotEvent.getBearingRadians() + (getHeadingRadians())) - getRadarHeadingRadians()));

	// movement
	if ((enemyLateralVelocity = (Math.sin(scannedRobotEvent.getHeadingRadians() - enemyAbsoluteBearing) * (enemyVelocity = scannedRobotEvent.getVelocity()))) != 0) {
	    Math.signum(enemyLateralVelocity);
	}
	tempDouble = PERPENDICULAR - ((enemyDistance = scannedRobotEvent.getDistance()) - PREFERRED_RANGE) / CLOSE_FACTOR;
	while (!(new Rectangle2D.Double(18, 18, 764, 564)).contains(project((new Point2D.Double(getX(), getY())), smoothedDirection = enemyAbsoluteBearing + _direction * (tempDouble -= SMOOTH_INC), WALL_STICK)))
	    ;
	if (((Math.random() < REVERSE_CHANCE * Math.sqrt(_enemyBulletVelocity / (enemyDistance + REVERSE_DIST_ADJ)) - REVERSE_SUB)) || tempDouble < REVERSE_ANGLE) {
	    _direction = -_direction;
	}
	setTurnRightRadians(Math.tan(smoothedDirection -= getHeadingRadians()));
	setMaxVelocity(7 + Math.random() * RANDOM_FACTOR);
	setAhead((MOVE_DISTANCE - Rules.getBulletSpeed(_lastEnemyEnergy - (_lastEnemyEnergy = scannedRobotEvent.getEnergy()))) * Math.signum(Math.cos(smoothedDirection)));

	// gun
	_enemyLog.insert(0, (char) (((int) Math.round(enemyVelocity * Math.sin(tempDouble = scannedRobotEvent.getHeadingRadians() - enemyAbsoluteBearing)) << 8) | (0XFF & ((byte) Math.round(enemyVelocity / 2 * Math.cos(tempDouble))))));
	setFire(bulletPower = enemyDistance < 100 ? 2.99 : Math.min(1.99, Math.min(_lastEnemyEnergy / 4, getEnergy() / 8)));
	int keyLength = Math.min(_enemyLog.length(), 66);
	int indexSize = 0;
	int[] index = new int[PATTERN_DEPTH];
	int tempIndex = 0;
	int[] bins = new int[BINS];
	try {
	    do {
		do {
		    if (tempIndex < 0) {
			keyLength = keyLength * 3 / 4;
		    }
		    tempIndex = _enemyLog.indexOf(_enemyLog.substring(0, keyLength), Math.max(((int) enemyDistance) / 11, tempIndex + 1));
		} while ((tempIndex < 0 || Arrays.binarySearch(index, tempIndex) >= 0) && keyLength > 0);
		if (keyLength == 0) {
		    break;
		}
		int iterateIndex = index[index.length - ++indexSize] = tempIndex;
		Arrays.sort(index);
		double db = 0;
		tempDouble = Math.PI;
		try {
		    do {
			char comboChar = _enemyLog.charAt(iterateIndex--);
			tempDouble += (byte) (comboChar >> 8) / (enemyDistance += 2 * (byte) (comboChar & 0XFF));
		    } while ((db += Rules.getBulletSpeed(bulletPower)) < enemyDistance);
		} catch (Exception exception) {
		}
		iterateIndex = 0;
		tempDouble = Utils.normalAbsoluteAngle(tempDouble) * ((BINS - 1) / (2 * Math.PI));
		try {
		    while (true) {
			bins[iterateIndex++] += keyLength / (1 + Math.abs(iterateIndex - tempDouble));
		    }
		} catch (Exception exception) {
		}
	    } while (true);
	} catch (Exception exception) {
	}
	keyLength = 0;
	tempIndex = (BINS - 1) / 2;
	try {
	    while (true) {
		if (bins[++keyLength] > bins[tempIndex]) {
		    tempIndex = keyLength;
		}
	    }
	} catch (Exception exception) {
	}
	setTurnGunRightRadians(Utils.normalRelativeAngle(enemyAbsoluteBearing - (Math.PI + 0.0005) + tempIndex * (2 * Math.PI / (BINS - 1)) - getGunHeadingRadians()));
    }

    private static Point2D.Double project(Point2D.Double location, double angle, double distance) {
	return new Point2D.Double(location.x + distance * Math.sin(angle), location.y + distance * Math.cos(angle));
    }
}
