   package jk.melee;
   
   import robocode.*;
   import robocode.util.*;
   import java.util.*;
   import java.awt.geom.*;
   import jk.mega.FastTrig;
   import ags.utils.*;
   import java.awt.Color;
		
    public class MeleeSurf{
   
   
      static  KdTree<MeleeScan> GF_0_tree = new KdTree.Manhattan<MeleeScan>(6,100);
      static{
         //FastTrig.init();
         GF_0_tree.addPoint(new double[]{0,0,0,0,0,0},new MeleeScan());
      }
      static Hashtable<String,EnemyInfo> enemies = new Hashtable<String,EnemyInfo>();
      static Hashtable<String,EnemyInfo> deadEnemies = new Hashtable<String,EnemyInfo>();
      ArrayList<MeleeWave> waves = new ArrayList<MeleeWave>();
      AdvancedRobot bot;
      public static Rectangle2D.Double fieldRect;
      double MAX_X, MAX_Y;
      ArrayList<Point2D.Double> testPoints = new ArrayList<Point2D.Double>();
      ArrayList<Point2D.Double> bestHitPoints;
      EnemyInfo me, lastMe, lastLastMe; 
      Point2D.Double[] pts;
      double[] dangers;
      ArrayList<Point2D.Double>[] hitPoints;
   
   	
       public MeleeSurf(AdvancedRobot abot){
         bot = abot;
         
         enemies.putAll(deadEnemies);
         deadEnemies.clear();  
         
         if(enemies.get(bot.getName()) == null){
            EnemyInfo me = new EnemyInfo();
            me.name = bot.getName();
            enemies.put(me.name,me);
         }
      	
         Enumeration<EnemyInfo> e = enemies.elements();
         // System.out.println("Simulated enemy gun enemies: " );
         while(e.hasMoreElements()){
            EnemyInfo eInfo = e.nextElement();
            eInfo.lastScanTime =0;
            // if(eInfo.targets != null){// 
               // System.out.print(eInfo.targets.size() + " ");
               // Enumeration<String> keys = eInfo.targets.keys();
               // while(keys.hasMoreElements())
                  // System.out.println(keys.nextElement());  
            // }
         }
         // System.out.println();
         MAX_X = bot.getBattleFieldWidth();
         MAX_Y = bot.getBattleFieldHeight();
         fieldRect = new Rectangle2D.Double(18,18,MAX_X - 36,MAX_Y - 36);
         
      }  
       public void onTick(){
         // lastLastMe = lastMe;
         lastMe = me;
       
         //me = enemies.get(bot.getName());
         //if(me == null){
         me = new EnemyInfo();
         me.name = bot.getName();
            //enemies.put(me.name,me);
         //}
      
      
         me.location = new Point2D.Double(bot.getX(), bot.getY());
         me.heading = bot.getHeadingRadians();
         me.velocity = bot.getVelocity();
         me.energy = bot.getEnergy();
         me.lastScanTime = (int)bot.getTime();
         me.name = bot.getName();
         // if(lastLastMe != null)
            // enemies.put(me.name,lastLastMe);  
         // else
         if(lastMe != null)
            enemies.put(me.name,lastMe);  
         else
            enemies.put(me.name,me);  
      	
         long time = bot.getTime();
         Iterator<MeleeWave> wit = waves.iterator();
         while(wit.hasNext()){
            MeleeWave mw = wit.next();
            double radius = mw.bulletVelocity*(time - mw.fireTime);
            Point2D.Double centre = mw.fireLocation;
            if( radius - 50 > centre.distance(new Point2D.Double(0,0))
            && radius > centre.distance(new Point2D.Double(0,MAX_Y))
            && radius > centre.distance(new Point2D.Double(MAX_X,0))
            && radius > centre.distance(new Point2D.Double(MAX_X,MAX_Y)))
               wit.remove();
         
         }
      //somehow work out which movement option intersects all waves the safest....
      
      //generate directions to check distance/parallism with all bots as this is a first criteria
         double closestEnemy = Double.POSITIVE_INFINITY;
         Enumeration<EnemyInfo> clen = enemies.elements();
         while(clen.hasMoreElements()){
            EnemyInfo ei = clen.nextElement();
            if(ei == me || ei == lastMe)
               continue;
            double d = ei.location.distance(me.location);
            if(d < closestEnemy)
               closestEnemy = d;
         }
         pts = new Point2D.Double[32];
         for(int i = 0; i < pts.length; i++)
            pts[i] = project(me.location,(i)*2*Math.PI/(double)pts.length,Math.min(160,closestEnemy*0.75));
         //   System.out.println(closestEnemy);
         dangers = new double[pts.length];
         testPoints.clear();
         
      //do some surfing!
      
         double minDanger = Double.POSITIVE_INFINITY;
         double goDir = 0;
         
         double[] enemyDangers = new double[pts.length];
         double[] waveDangers = new double[pts.length];
         hitPoints = new ArrayList[pts.length];
         
         for(int i = 0; i < pts.length; i++){
         
            if(fieldRect.contains(pts[i]))
               testPoints.add(pts[i]);
            else{
               enemyDangers[i] = waveDangers[i] = Double.POSITIVE_INFINITY;
               continue;
            }
           
            Enumeration<EnemyInfo> en = enemies.elements();
            while(en.hasMoreElements()){
               EnemyInfo ei = en.nextElement();
               if(ei == me || ei == lastMe)
                  continue;
               double dist = new Line2D.Double(pts[i],me.location).ptSegDist(ei.location);
               // double dist = pts[i].distance(ei.location);
               double closest = 1;	
               Enumeration<EnemyInfo> ens = enemies.elements();
               double minEDist = Double.POSITIVE_INFINITY;
               while(ens.hasMoreElements()){
                  EnemyInfo eni = ens.nextElement();
                  if(eni == me)
                     continue;
                  double eDist = eni.location.distance(ei.location);
                  if(eDist  < minEDist)
                     minEDist = eDist;
                  if(dist < eDist)
                     closest++;    
                  
               }
               closest = Math.min(3,closest);
               if(dist < 0.9*minEDist){
               
                  double anglediff = absoluteBearing(me.location,pts[i]) - absoluteBearing(ei.location,me.location);
               
                  enemyDangers[i] += ei.energy/(dist*dist ) * closest * (1 + Math.abs(Math.cos(anglediff)));
               
               }
               else{
                  enemyDangers[i] += ei.energy/(dist*dist ) * closest;
               
               }
            
            }
            //enemyDangers[i] *= closest;
            hitPoints[i] = new ArrayList<Point2D.Double>();
         		
            Iterator<MeleeWave> it = waves.iterator();
            while(it.hasNext()){
               MeleeWave w = it.next();
               
               if(me.location.distance(w.fireLocation) - 18 < w.bulletVelocity*(time - w.fireTime))
                  continue;  
            	
               Point2D.Double hitPoint = futureStatus(me.location,pts[i],me.velocity,me.heading,time,w);
               hitPoints[i].add(hitPoint);
            	
               if(!fieldRect.contains(hitPoint)){
                  waveDangers[i] = Double.POSITIVE_INFINITY;
                  continue;
               }
               
               
               double bearing = Utils.normalAbsoluteAngle(absoluteBearing(w.fireLocation,hitPoint));
                     
               double botWidth = 40/w.fireLocation.distance(hitPoint);
                     
               double scale = 180/Math.PI;
               double a1 = Utils.normalAbsoluteAngle(bearing - botWidth*0.5);
               double a2 = Utils.normalAbsoluteAngle(bearing + botWidth*0.5);
               double waveDanger =  botWidth*botWidth*averageDanger((int)(scale*a1), (int)(scale*a2), w.bins);
               // double waveDanger = botWidth*w.bins[(int)(scale*bearing)];
            	
               double waveWeight = w.bulletDamage/
                  Math.abs(me.location.distance(w.fireLocation)/w.bulletVelocity - (time - w.fireTime));
            	
            	
               waveDangers[i] += waveWeight*waveDanger;
            
            }
         
         }
       
         medianNormalize(enemyDangers);
         medianNormalize(waveDangers);
      	
         double[] dangerWeights = {1,5};//{bot.getOthers(),bot.getOthers() + waves.size()};
         for(int i = 0; i < pts.length; i++){
            dangers[i] =  dangerWeights[0]*enemyDangers[i] + 
               dangerWeights[1]*waveDangers[i];
         
            if(dangers[i] < minDanger){
               minDanger = dangers[i];
               goDir = absoluteBearing(me.location,pts[i]);
               bestHitPoints = hitPoints[i];
            }
         }
      
         double headingDiff = goDir - bot.getHeadingRadians();
         bot.setTurnRightRadians(Math.tan(headingDiff));
         bot.setAhead(Double.POSITIVE_INFINITY*Math.cos(headingDiff));
         
      }
       public double averageDanger(int i1, int i2, double[] bins){
         double d = 0;
         if(i1 < i2){
            for(int i = i1; i <= i2; i++)
               d += bins[i];
            d /= i2 - i1 + 1;
         }
         else{
            for(int i = i1; i < bins.length; i++)
               d += bins[i];
            for(int i = 0; i <= i2; i++)
               d += bins[i];
            d /= bins.length - i1 + i2 + 1;
         }
      
         return d;
      }
       public static void areaNormalize(double[] bins){
         double total = 0;
         //double min = Double.POSITIVE_INFINITY;
         for(int i = 0; i < bins.length; i++){
            if(bins[i] != Double.POSITIVE_INFINITY){
               total += bins[i];
               //if(bins[i] < min)
                  //min = bins[i];   
            }
         }
         if(total != 0){
            total = 1/total;
            for(int i = 0; i < bins.length; i++)
               if(bins[i] != Double.POSITIVE_INFINITY){
                  //bins[i] = (bins[i] - min)* total;
                  bins[i] *= total;
               }
         }
      }
       public static void medianNormalize(double[] bins){
         double[] sortedBins = new double[bins.length];
         System.arraycopy(bins,0,sortedBins,0,bins.length);
         Arrays.sort(sortedBins);
         int minReal = 0;
         while(minReal < bins.length && sortedBins[minReal] == 0)minReal++;
         int maxReal = minReal;
         while(maxReal < bins.length && !Double.isInfinite(sortedBins[maxReal]))maxReal++;
      	
      	
         double scale = 1/(1e-30 + sortedBins[(int)limit(0,(minReal + maxReal)/2 - 1,bins.length - 1)]);
      
         for(int i = 0; i < bins.length; i++)
            if(bins[i] != Double.POSITIVE_INFINITY){
                  //bins[i] = (bins[i] - min)* total;
               bins[i] *= scale;
            }
         
      }
       public static void normalize(double[] bins){
         double max = 0, min = Double.POSITIVE_INFINITY;
         for(int i = 0; i < bins.length; i++){
            if(bins[i] != Double.POSITIVE_INFINITY && bins[i] > max)
               max = bins[i];
            if(bins[i] < min)
               min = bins[i];
         }
         if(max != min){
            max = 1/(max-min);
            for(int i = 0; i < bins.length; i++)
               if(bins[i] != Double.POSITIVE_INFINITY)
                  bins[i] = (bins[i]-min)*max;
         }
      }
       public void onPaint(java.awt.Graphics2D g){
      
         g.setColor(Color.red);
      
         Iterator<Point2D.Double> pi = testPoints.iterator();
         while(pi.hasNext()){
            Point2D.Double p = pi.next();
            g.drawOval((int)p.x - 3, (int)p.y - 3, 6,6);
         
         }
      
         g.setColor(Color.green);
         g.drawOval((int)me.location.x - 20, (int)me.location.y - 20, 40,40);
         long time = bot.getTime();
         Iterator<MeleeWave> wit = waves.iterator();
         while(wit.hasNext()){
            MeleeWave w = wit.next();
            double bDist = w.bulletVelocity*(time - w.fireTime);
           
            g.setColor(Color.orange);
            
         	
           // // for(int i = 0; i < w.bins.length; i++){
               // Point2D.Double p = project(w.startFiredFrom,i*(Math.PI*2), sDist);
               // g.drawOval((int)p.x - 1, (int)p.y - 1, 2,2);
            // }
            g.drawOval((int)w.fireLocation.x - (int)bDist, (int)w.fireLocation.y - (int)bDist, 2*(int)bDist, 2*(int)bDist);
            g.setColor(Color.white);
            
            
            EnemyInfo meInfoAtFire = w.snapshot.get(me.name);
            
            // if(meInfoAtFire == null)
               // System.out.println("me not in snapshot, snapshot size = " + w.snapshot.size());
            Point2D.Double meAtFire = meInfoAtFire.location;
          
            double GF0 = absoluteBearing(w.fireLocation, meAtFire);
            double MEA = maxEscapeAngle(w.bulletVelocity);
            double a1 = GF0 - MEA;
            double a2 = GF0 + MEA;
            
            int index1 = (int)((180/Math.PI)*a1 + 360)%360;
            int index2 = (int)((180/Math.PI)*a2 + 360)%360;
            
            if(index1 < index2){
               double maxD = 0;
               for(int i = 0; i < w.bins.length; i++){
                  if(w.bins[i] > maxD)
                     maxD = w.bins[i];
               }
               for(int i = index1; i < index2; i++){
                  double relDanger = w.bins[i]/maxD;
                  
                  boolean paint = false;
                  if(relDanger == 1){
                     g.setColor(Color.red);
                     paint =true;}
                  else if(relDanger > 0.8){
                     g.setColor(Color.orange);
                     paint =true;}
                  else if(relDanger > 0.6){
                     g.setColor(Color.yellow);
                     paint =true;}
                  else if(relDanger > 0.4){
                     g.setColor(Color.green);
                     paint =true;}
                  else if(relDanger > 0.2)
                     g.setColor(Color.blue);
                  else
                     g.setColor(Color.black);
                  if(paint){
                     Point2D.Double p = project(w.fireLocation,i*Math.PI/180,bDist);
                     g.drawOval((int)p.x - 3, (int)p.y - 3, 6, 6);
                  }
                  
               }
            }
            else{
               double maxD = 0;
               for(int i = 0; i < w.bins.length; i++){
                  if(w.bins[i] > maxD)
                     maxD = w.bins[i];
               }
               for(int i = index1; i <w.bins.length; i++){
                  double relDanger = w.bins[i]/maxD;
                  boolean paint = false;
                  if(relDanger == 1){
                     g.setColor(Color.red);
                     paint =true;}
                  else if(relDanger > 0.8){
                     g.setColor(Color.orange);
                     paint =true;}
                  else if(relDanger > 0.6){
                     g.setColor(Color.yellow);
                     paint =true;}
                  else if(relDanger > 0.4){
                     g.setColor(Color.green);
                     paint =true;}
                  else if(relDanger > 0.2)
                     g.setColor(Color.blue);
                  else
                     g.setColor(Color.black);
                  if(paint){
                     Point2D.Double p = project(w.fireLocation,i*Math.PI/180,bDist);
                     g.drawOval((int)p.x - 3, (int)p.y - 3, 6, 6);
                  }
               }
               for(int i = 0; i <= index2; i++){
                  double relDanger = w.bins[i]/maxD;
                  
                  boolean paint = false;
                  if(relDanger == 1){
                     g.setColor(Color.red);
                     paint =true;}
                  else if(relDanger > 0.8){
                     g.setColor(Color.orange);
                     paint =true;}
                  else if(relDanger > 0.6){
                     g.setColor(Color.yellow);
                     paint =true;}
                  else if(relDanger > 0.4){
                     g.setColor(Color.green);
                     paint =true;}
                  else if(relDanger > 0.2)
                     g.setColor(Color.blue);
                  else
                     g.setColor(Color.black);
                  if(paint){
                     Point2D.Double p = project(w.fireLocation,i*Math.PI/180,bDist);
                     g.drawOval((int)p.x - 3, (int)p.y - 3, 6, 6);
                  }               }
            }
         	
         }
         double maxDanger = 0;
         for(int i = 0; i < dangers.length; i++)
            if(dangers[i] > maxDanger && dangers[i] != Double.POSITIVE_INFINITY)
               maxDanger = dangers[i];
         for(int i = 0; i < pts.length; i++){
            Point2D.Double p = pts[i];
            double relDanger = dangers[i]/maxDanger;
            if(relDanger == Double.POSITIVE_INFINITY)
               g.setColor(Color.magenta);
            else if(relDanger == 1)
               g.setColor(Color.red);
            else if(relDanger > 0.8)
               g.setColor(Color.orange);
            else if(relDanger > 0.6)
               g.setColor(Color.yellow);
            else if(relDanger > 0.4)
               g.setColor(Color.green);
            else if(relDanger > 0.2)
               g.setColor(Color.blue);
            else
               g.setColor(Color.black);
         
            g.drawLine((int)p.x, (int)p.y, (int)me.location.x, (int)me.location.y);
         }
         
         g.setColor(Color.white);
         if(hitPoints != null)
            for(int i = 0; i < hitPoints.length; i++)
               for(int j = 0; hitPoints[i] != null && j < hitPoints[i].size(); j++){
                  Point2D.Double p = hitPoints[i].get(j);
                  g.drawOval((int)p.x - 1, (int)p.y - 1, 2, 2);
               }
            
      }
       public void onScannedRobot(ScannedRobotEvent e){
      
         EnemyInfo eInfo = enemies.get(e.getName());
         double absBearing = e.getBearingRadians() + bot.getHeadingRadians();
         Point2D.Double newELocation =project(me.location,absBearing,e.getDistance());
         
         if(eInfo == null){
            enemies.put(e.getName(), eInfo = new EnemyInfo());
            eInfo.name = e.getName();
            // System.out.println("adding " + eInfo.name);
         }
         else{
            double deltaE = eInfo.energy - e.getEnergy();
            long deltaT = Math.max(0,bot.getTime() -eInfo.lastScanTime);
            if(eInfo.lastScanTime != 0 && deltaT != 0 ){
            
            
            //check gunheat: if (gunheat> 0) fired = false;
               double gunHeat = eInfo.gunHeat -= deltaT*bot.getGunCoolingRate();
               boolean fired = gunHeat <= bot.getGunCoolingRate();
            
            //check for overlapping waves
               MeleeWave bestOverlap = getBestOverlapExcluding(newELocation,deltaE,eInfo.name,false);            
               if (bestOverlap != null && Math.abs(deltaE-bestOverlap.bulletDamage) < 0.01){
                  logWaveHit(bestOverlap, newELocation, eInfo);
               }
               
               else if(
               (bestOverlap == null || deltaE < bestOverlap.bulletDamage)
                   && fired && 0 < deltaE && deltaE <= 3 )//they fired!
                  addWave(eInfo,newELocation,deltaE);
                  
               else{
                  bestOverlap = getBestOverlapExcluding(newELocation,deltaE,eInfo.name,true); 
               
                  if(fired && bestOverlap != null &&  bestOverlap.bulletDamage < deltaE && deltaE <= bestOverlap.bulletDamage + 3){
                  
                     addWave(eInfo,newELocation,deltaE - bestOverlap.bulletDamage);
                     logWaveHit(bestOverlap, newELocation ,eInfo);
                  
                  
                  }
                  
                  else if(bestOverlap == null);//can't find wave!
               }
            }
         
         
         
         
         }
         eInfo.heading = e.getHeadingRadians();
         eInfo.velocity = e.getVelocity();
         eInfo.lastEnergy = eInfo.energy;
         eInfo.energy = e.getEnergy();
         eInfo.lastScanTime = (int)bot.getTime();
         eInfo.location = newELocation;
      }
       public void onRobotDeath(RobotDeathEvent ev){
         EnemyInfo e = enemies.remove(ev.getName());
         if(e != null)
            deadEnemies.put(e.name,e);
      }
       public void onHitByBullet(HitByBulletEvent ev){
         Bullet b = ev.getBullet();
         logBullet(b);
         EnemyInfo e = enemies.get(b.getName());
         if(e != null){
            e.energy += b.getPower()*3;
         }
      
      }
       public void onBulletHitBullet(BulletHitBulletEvent e){
         logBullet(e.getBullet());
      }
       public void onBulletHit(BulletHitEvent ev){
         Bullet b = ev.getBullet();
         EnemyInfo e = enemies.get(ev.getName());
         if(e != null){
            double power = b.getPower();
            double damage = 4*power;
            if(power > 1)
               damage += 2*(power - 1);
            e.energy -= damage;
            double deltaE = e.energy - ev.getEnergy();
            if(deltaE <= 3 && deltaE > 0.01){
               Point2D.Double newLocation = new Point2D.Double(b.getX(),b.getY());
               addWave(e,newLocation,deltaE);
            }
            e.energy = ev.getEnergy();
         }
      
      }
       public void addWave(EnemyInfo firer, Point2D.Double newELocation, double deltaE){
        
        
         firer.gunHeat = Rules.getGunHeat(deltaE) - bot.getGunCoolingRate()*(bot.getTime() - firer.lastScanTime);
         MeleeWave w = new MeleeWave();
               //take a "snapshot" of where everybody is, and their direction and energy etc
               //and store it in the wave
         w.snapshot = new Hashtable<String,EnemyInfo>();
         Enumeration<EnemyInfo> en = enemies.elements();
         while(en.hasMoreElements()){
            EnemyInfo ei = en.nextElement();
            if(ei.name == firer.name)
               continue;
            EnemyInfo cp = new EnemyInfo();
            cp.location = ei.location;
            cp.energy = ei.energy;
            cp.name = ei.name;
            cp.heading = ei.heading;
            cp.velocity = ei.velocity;
            w.snapshot.put(cp.name,cp);
                     
            double targetBearing = absoluteBearing(firer.location,cp.location);
            double latVel = cp.velocity*FastTrig.sin(cp.heading - targetBearing);
            double advVel = cp.velocity*FastTrig.cos(cp.heading - targetBearing);
            double distToE = cp.location.distance(firer.location);
            double distToNearest = distToE * distToE;
            Enumeration<EnemyInfo> all = enemies.elements();
            while(all.hasMoreElements()){
               EnemyInfo ein = all.nextElement();
               if(ein.name.equals(cp.name))
                  continue;
               double distSq = ein.location.distance(cp.location);
               if(distSq < distToNearest)
                  distToNearest = distSq;
            }
            distToNearest = Math.sqrt(distToNearest);
            double distToWall = Math.min(
                           Math.min(cp.location.x - 18,cp.location.y - 18),
                           Math.min(MAX_X - 18 - cp.location.x, MAX_Y - 18 - cp.location.y)); 
            double enemiesAlive = bot.getOthers();
                     
            double[] location = { 
                              latVel *(20/8.0),
                              advVel *(12/8.0),
                              distToE * (3/1200.0),
                              distToNearest * (10/1200.0),
                              distToWall * (4/600.0),
                              enemiesAlive*2};
            cp.treeLocation = location;
                     
         }
                  // System.out.println("Snapshot size: " + w.snapshot.size() + " Enemies: " + enemies.size());
         w.firedBy = firer.name;
         w.fireLocation =// project(eInfo.location, eInfo.heading, -eInfo.velocity);
                     new Point2D.Double(0.5*(firer.location.x + newELocation.x),
                     0.5*(firer.location.y + newELocation.y));
         w.fireTime = (long)Math.round((firer.lastScanTime + bot.getTime() - 1)*0.5);
         w.bulletPower = deltaE;
         w.bulletVelocity = 20 - 3*deltaE;
         w.bulletDamage = Rules.getBulletDamage(deltaE);
               //create a set of bins that cover 360 degrees
         w.bins = new double[360];
               //for each enemy that i have targeting data from this bot for:
         en = enemies.elements();
         if(firer.targets == null)
            firer.targets = new Hashtable<String,KdTree<MeleeScan>>();
                     
         while(en.hasMoreElements()){
            EnemyInfo target = en.nextElement();
            KdTree<MeleeScan> tree = firer.targets.get(target.name);
                     //// - weight top 3 scans by inverse distance from 'actual scan', 
                     ////    based on what they are doing from his perspective, 
                     ////    weight each bot by inverse distance-to-him squared
                     
            if(target.name.equals(firer.name))
               continue;
                  	
            double targetBearing = absoluteBearing(firer.location,target.location);
            double latVel = target.velocity*FastTrig.sin(target.heading - targetBearing);
            double advVel = target.velocity*FastTrig.cos(target.heading - targetBearing);
            double distToE = target.location.distance(firer.location);
            double distToNearest = distToE * distToE;
            Enumeration<EnemyInfo> all = enemies.elements();
            while(all.hasMoreElements()){
               EnemyInfo ei = all.nextElement();
               if(ei == target)
                  continue;
               double distSq = ei.location.distanceSq(target.location);
               if(distSq < distToNearest)
                  distToNearest = distSq;
            }
            distToNearest = Math.sqrt(distToNearest);
            double distToWall = Math.min(
                           Math.min(target.location.x - 18,target.location.y - 18),
                           Math.min(MAX_X - 18 - target.location.x, MAX_Y - 18 - target.location.y)); 
            double enemiesAlive = bot.getOthers();
                     
            double[] location = { 
                              latVel *(20/8.0),
                              advVel *(12/8.0),
                              distToE * (3/1200.0),
                              distToNearest * (10/1200.0),
                              distToWall * (4/600.0),
                              enemiesAlive*2};
            target.treeLocation = location;
                     
            int k = 0;
            if(tree == null)
               if(firer.defaultAim != null){
                  tree = firer.defaultAim;
                  k = 1;     
               }
               else{
                  tree = GF_0_tree;
                  k = 1;     
               }
                              
            double GFcorrection = Math.signum(latVel)*maxEscapeAngle(w.bulletVelocity);
                     
            double botWeight = 1/(distToE*distToE);//+10*target.energy);
            double[] bins = new double[360];
                     
            do{
                        
               List<KdTree.Entry<MeleeScan>> cluster = tree.nearestNeighbor(
                              location,
                              Math.min(10,tree.size()),
                              true
                              );
                        
                        
               Iterator<KdTree.Entry<MeleeScan>> it = cluster.iterator();
               double weight = botWeight*Math.exp(-k);      
               while(it.hasNext()){
                  KdTree.Entry<MeleeScan> v = it.next();
                  double fireAngle = Utils.normalAbsoluteAngle
                                 (v.value.GF*GFcorrection + targetBearing);
                           
                           // w.bins[((int)(0.5 + fireAngle*(180/Math.PI)))%360] +=botWeight/(1e-5 + v.distance);
                  smoothAround(bins,((int)(fireAngle*(180/Math.PI)))%360,
                                 18,v.value.weight*weight/(1e-15 + v.distance));
               }
               k++;
                        
                        // botWeight = botWeight*Math.exp(-tree.size());
               tree = firer.defaultAim;
                        
            }while(k == 1);
                     
                     
            areaNormalize(bins);
            for(int i = 0; i < bins.length; i++)
               w.bins[i] += botWeight*bins[i];
                  	
                     //// - smooth these into the 360* buffer
                     //make an 'average' targeting set that we use on all the bots we don't have
                     //targeting data for, then do the same
         }
                 
         areaNormalize(w.bins);
               //TODO:figure out 'start' and 'end' of wave based on deltaT since last scan,
               //when their gunheat became 0
               
               //add wave!
         waves.add(w);
      }  
       public void logWaveHit(MeleeWave bestOverlap, Point2D.Double newELocation, EnemyInfo eInfo){
      
                 //log hit
               ////- find offset from who we think was being targeted (closest bot within GF +-1)
               //increase energy of targeter bot
               
               //assume they were targeting the bot that got hit for now...
         double closest = Double.POSITIVE_INFINITY;
               
         Enumeration<EnemyInfo> it = bestOverlap.snapshot.elements();
         while(it.hasMoreElements()){
                  
            EnemyInfo firedTargetInfo = it.nextElement();
            double cdist = firedTargetInfo.location.distance(bestOverlap.fireLocation);
            if(cdist < closest)
               closest =cdist;
         }
         double inv_closest = 1/closest;
               
               
         it = bestOverlap.snapshot.elements();
         while(it.hasMoreElements()){
                  
            EnemyInfo firedTargetInfo = it.nextElement();
                  
            double fireBearing = absoluteBearing(bestOverlap.fireLocation,
                           firedTargetInfo.location);
            double hitBearing = absoluteBearing(bestOverlap.fireLocation,
                           newELocation);
                           
            double offset = Utils.normalRelativeAngle(hitBearing - fireBearing);
                     
                  
            double latVel = firedTargetInfo.velocity*
                        FastTrig.sin(firedTargetInfo.heading - fireBearing);
                  
            double GF = offset*Math.signum(latVel)/maxEscapeAngle(bestOverlap.bulletVelocity);
            if(GF > 1 || GF < -1)
               continue;
            EnemyInfo firer = enemies.get(bestOverlap.firedBy);
            if(firer == null)
               firer = deadEnemies.get(bestOverlap.firedBy);
            if(firer != null){
               if(firedTargetInfo.treeLocation == null){
                  System.out.println("tree location is null!");
                  continue;
               }
               KdTree firerTree = firer.targets.get(eInfo.name);
               if(firer.defaultAim == null )
                  firer.defaultAim = new KdTree.Manhattan(firedTargetInfo.treeLocation.length,new Integer(10000));
              
               if(firerTree == null ){
                  firerTree = new KdTree.Manhattan(firedTargetInfo.treeLocation.length,new Integer(10000));
                  firer.targets.put(eInfo.name,firerTree);
               }
               
               MeleeScan ms = new MeleeScan();
               ms.GF = GF;
               ms.weight = Math.exp(-2*firedTargetInfo.location.distance(bestOverlap.fireLocation)*inv_closest);
                     
               firerTree.addPoint(firedTargetInfo.treeLocation,ms);
               // System.out.println("adding target info on " + eInfo.name + " to " + firer.name);   
               firer.defaultAim.addPoint(firedTargetInfo.treeLocation,ms);
            }
         }
                  
         EnemyInfo firer = enemies.get(bestOverlap.firedBy);
         if(firer != null){
            if(firer.energy - firer.lastEnergy - bestOverlap.bulletPower*3 < -0.01)
            //firer = deadEnemies.get(bestOverlap.firedBy);
               firer.energy += bestOverlap.bulletPower*3;
            
         }
         waves.remove(bestOverlap);
      
      }
   	
       public void logBullet(Bullet b){
      
         MeleeWave bestOverlap = getBestOverlapBy(new Point2D.Double(b.getX(), b.getY()),
            Rules.getBulletDamage(b.getPower()), b.getName());
         EnemyInfo eInfo = enemies.get(bot.getName());
         double closest = Double.POSITIVE_INFINITY;
         if(bestOverlap == null || bestOverlap.snapshot == null){
            // System.out.println("Can't find wave for bullet hit");
            return;
         }
            
         Enumeration<EnemyInfo> it = bestOverlap.snapshot.elements();
         while(it.hasMoreElements()){
                  
            EnemyInfo firedTargetInfo = it.nextElement();
            double cdist = firedTargetInfo.location.distance(bestOverlap.fireLocation);
            if(cdist < closest)
               closest =cdist;
         }
         double inv_closest = 1/closest;
            
         double hitBearing = absoluteBearing(bestOverlap.fireLocation, eInfo.location);   
               
         it = bestOverlap.snapshot.elements();
         while(it.hasMoreElements()){
                  
            EnemyInfo firedTargetInfo = it.nextElement();
            if(firedTargetInfo.name == bestOverlap.firedBy)
               continue;
               
            double fireBearing = absoluteBearing(bestOverlap.fireLocation,
                           firedTargetInfo.location);
         
            double offset = Utils.normalRelativeAngle(hitBearing - fireBearing);
                  
            double latVel = firedTargetInfo.velocity*FastTrig.sin(firedTargetInfo.heading - fireBearing);
                  
            double GF = offset*Math.signum(latVel)/maxEscapeAngle(bestOverlap.bulletVelocity);
            if(GF > 1 || GF < -1){
               // System.out.println("hitwave out of gf range for " + firedTargetInfo.name);
               continue;
            }
            EnemyInfo firer = enemies.get(bestOverlap.firedBy);
            if(firer == null)
               firer = deadEnemies.get(bestOverlap.firedBy);
            if(firer != null ){
               if(firer.targets == null)
                  firer.targets = new Hashtable<String,KdTree<MeleeScan>>();
               KdTree firerTree = firer.targets.get(eInfo.name);
               if(firerTree == null && firedTargetInfo.treeLocation != null){
                  firerTree = new KdTree.Manhattan(firedTargetInfo.treeLocation.length,new Integer(10000));
                  firer.targets.put(eInfo.name,firerTree);
               }
               if(firedTargetInfo.treeLocation == null)
                  System.out.println("Fired Target Info NULL");
               MeleeScan ms = new MeleeScan();
               ms.GF = GF;
               ms.weight = Math.exp(-.5*firedTargetInfo.location.distance(bestOverlap.fireLocation)*inv_closest);
               if(firedTargetInfo.treeLocation != null)
                  firerTree.addPoint(firedTargetInfo.treeLocation,ms);
              
               if(firer.defaultAim == null && firedTargetInfo.treeLocation != null)
                  firer.defaultAim = new KdTree.Manhattan(firedTargetInfo.treeLocation.length,new Integer(10000));
               if(firedTargetInfo.treeLocation != null)
                  firer.defaultAim.addPoint(firedTargetInfo.treeLocation,ms);
            }
            else
               System.out.println("Got wave but not firer...");
         }
         
         //System.out.println("firer: " + bestOverlap.firedBy);
         EnemyInfo firer = enemies.get(bestOverlap.firedBy);
         if(firer != null){
            if(firer.energy - firer.lastEnergy - bestOverlap.bulletPower*3 < -0.01)
            //firer = deadEnemies.get(bestOverlap.firedBy);
               firer.energy += bestOverlap.bulletPower*3;
         }
         
         waves.remove(bestOverlap);
               
      }
       MeleeWave getBestOverlapBy(Point2D.Double location, double bulletDamage, String name){
       
         
         MeleeWave bestOverlap = null;
         double dist = Double.POSITIVE_INFINITY;
         for(int i = 0, k = waves.size(); i < k; i++){
            MeleeWave overlap = waves.get(i);
            if(overlap.firedBy == name
            &&
            Math.abs(overlap.fireLocation.distance(location) -
                  (bot.getTime() - overlap.fireTime)*overlap.bulletVelocity) 
            		< 8*overlap.bulletVelocity
                  //&& sqr(overlap.bulletDamage - bulletDamage) < 0.01
                  ){
                  //rank overlapping waves in order of likelyhood, incorporating:
                  ////- how near deltaE is to this wave's damage (mostly)
                  ////- how long the wave had to travel (less is better) (weighted just as tie-breaker)
                       ////TODO: use all, and eliminate the ones whose bots do not get a hit bonus
               double thisDist =  sqr(overlap.bulletDamage - bulletDamage) + (bot.getTime() - overlap.fireTime)*0.001;
               if(thisDist < dist){
                  bestOverlap = overlap;
                  dist = thisDist;
               }
                     
            }
         }
         return bestOverlap;
       
      }
       MeleeWave getBestOverlapExcluding(Point2D.Double location, double bulletDamage, String excludeName, boolean allow1Fire){
       
         
         MeleeWave bestOverlap = null;
         double dist = Double.POSITIVE_INFINITY;
         for(int i = 0, k = waves.size(); i < k; i++){
            MeleeWave overlap = waves.get(i);
            if(!overlap.firedBy.equals(excludeName)
            &&
            Math.abs(overlap.fireLocation.distance(location) -
                  (bot.getTime() - overlap.fireTime)*overlap.bulletVelocity) 
            		< 8*overlap.bulletVelocity
                  //&& sqr(overlap.bulletDamage - bulletDamage) < 0.01
                  ){
                  //rank overlapping waves in order of likelyhood, incorporating:
                  ////- how near deltaE is to this wave's damage (mostly)
                  ////- how long the wave had to travel (less is better) (weighted just as tie-breaker)
                       ////TODO: use all, and eliminate the ones whose bots do not get a hit bonus
               double thisDist =  
                  
                  ((0 < (bulletDamage - overlap.bulletDamage)
                  && (bulletDamage - overlap.bulletDamage) <= 3
                  && allow1Fire)
                  ?0:Math.abs(bulletDamage - overlap.bulletDamage))
                  
                  + (bot.getTime() - overlap.fireTime)*0.01;
               if(thisDist < dist){
                  bestOverlap = overlap;
                  dist = thisDist;
               }
                     
            }
         }
         return bestOverlap;
       
      }
   
       public static void smoothAround(double[] bins, int index, int width, double weight){
       
         int minIndex = (index - 2*width + 2*bins.length)%bins.length, maxIndex = (index + 2*width)%bins.length;
         double invWidth = 1.0/width;
      
         if(minIndex > index){
            for(int i = minIndex; i < bins.length ; i++)
               bins[i] += weight/(sqr(i - bins.length - index)*invWidth + 1);
                  
            for(int i = 0; i < index; i++)
               bins[i] += weight/(sqr(i - index)*invWidth + 1);
         }
         else
            for(int i = minIndex; i < index; i++)
               bins[i] += weight/(sqr(i - index)*invWidth + 1);
                  
         if(maxIndex < index){
            for(int i = index; i < bins.length; i++)
               bins[i] += weight/(sqr(i - index)*invWidth + 1);
            
            for(int i = 0; i <= maxIndex; i++)
               bins[i] += weight/(sqr(i + bins.length - index)*invWidth + 1);
         }
         else
            for(int i = index; i <= maxIndex; i++)
               bins[i] += weight/(sqr(i - index)*invWidth + 1);
        
         
      	
       
         // bins[index] += weight;
         // double invWidth = 1.0/width;
      //       
         // int oppIndex = index + bins.length>>1;
         // if(oppIndex > bins.length){
         // 
            // for(int i = oppIndex - bins.length; i >= 0; i--)
               // bins[i] += weight/(sqr(i + bins.length - index)*invWidth + 1);
         //       
            // for(int i = oppIndex- bins.length; i < bins.length; i++)
               // bins[i] += weight/(sqr(i - index)*invWidth + 1);
         //      
         // }
         // else{
         // 
            // for(int i = oppIndex; i >= 0; i--)
               // bins[i] += weight/(sqr(i - index)*invWidth + 1);
         //       
            // for(int i = oppIndex; i < bins.length; i++)
               // bins[i] += weight/(sqr(i - bins.length - index)*invWidth + 1);
         //       
         // 
         // }
      }
       public static int sqr(int i){
         return i*i;}
       public static double sqr(double d){
         return d*d;}
   
       static class PredictionStatus{  
         double  finalHeading, finalVelocity, distanceRemaining;
         long time;
         Point2D.Double endPoint;
         boolean debug;
      }
         	//3 optimized methods from the new robocode engine
       private static double getNewVelocity(double velocity, double distance) {
         final double goalVel = Math.min(getMaxVelocity(distance), 8);
      
         if(velocity >= 0)
            return limit(velocity - 2,
               goalVel, velocity + 1);
        
         return limit(velocity - 1,
            goalVel, velocity + maxDecel(-velocity));
      }
   
       final static double getMaxVelocity(double distance) {
         final double decelTime =  Math.max(1,Math.ceil(
            //sum of 0... decelTime, solving for decelTime 
            //using quadratic formula, then simplified a lot
            Math.sqrt(distance + 1) - 0.5));
      
         final double decelDist = (decelTime) * (decelTime-1) ;
            // sum of 0..(decelTime-1)
            // * Rules.DECELERATION*0.5;
      
         return ((decelTime - 1) * 2) + ((distance - decelDist) / decelTime);
      }
    
       private static final double maxDecel(double speed) {
         return limit(1,speed*0.5 + 1, 2);
      }
       public static Point2D.Double futureStatus(Point2D.Double fromLocation, Point2D.Double toLocation, double initialVelocity, double initialHeading, long currentTime, MeleeWave wave){
      
         double wantedHeading = absoluteBearing(fromLocation,toLocation);
         double velocity = initialVelocity;
         double distanceRemaining = fromLocation.distance(toLocation);;
         long time = currentTime;
         double theta = Utils.normalRelativeAngle(wantedHeading - initialHeading);
         double offsetSign = Math.signum(theta);
         theta = Math.abs(theta);
      	
         PredictionStatus status = new PredictionStatus();
         status.finalHeading = initialHeading;
         
         if(theta > Math.PI/2){
            theta = Math.PI - theta;
            velocity = -velocity;
            offsetSign = -offsetSign;
            status.finalHeading = Utils.normalAbsoluteAngle(initialHeading + Math.PI);
         }
         
         double waveCenterDist = wave.fireLocation.distance(fromLocation);
         double waveBearing =  absoluteBearing(fromLocation,wave.fireLocation);
         double waveOffset = Utils.normalAbsoluteAngle(waveBearing - status.finalHeading);
         double waveOffsetSign = 1;
         if(waveOffset > Math.PI){
            waveOffset = 2*Math.PI - waveOffset;
            waveOffsetSign = -waveOffsetSign;  
         }
         
         do{
            double deltaHeading = (theta - (theta = Math.max(0,theta - (Math.PI/18) + (Math.PI/240)*Math.abs(velocity))))*offsetSign;
            status.finalHeading += deltaHeading;
            waveOffset -= deltaHeading*waveOffsetSign;
            if(waveOffset > Math.PI){
               waveOffset = 2*Math.PI - waveOffset;
               waveOffsetSign = -waveOffsetSign;  
            }
            else if(waveOffset < 0){
               waveOffset = -waveOffset;
               waveOffsetSign = -waveOffsetSign;
            
            }
            // velocity = getNewVelocity(velocity, distanceRemaining);
         
         // 	/*
            if(velocity >= 0 && distanceRemaining >= decelDistance(velocity))
               velocity = Math.min(velocity + 1, 8);
            else
               velocity = limit(-1.9999999999, Math.abs(velocity) - Math.min(Math.max(Math.abs(velocity),distanceRemaining),2), 6)*(velocity<0?-1:1);
         //    */
         	   
            if(theta == 0)
               distanceRemaining -= velocity;
            else{ //rule of cosines
               double oldDistRemSq = distanceRemaining*distanceRemaining;
               double distRemSq = velocity*velocity + oldDistRemSq - 2*velocity*distanceRemaining*FastTrig.cos(theta);
               if(distRemSq <= 0.1)
                  distanceRemaining = 0;
               else{
                  distanceRemaining = Math.sqrt(distRemSq);
               
                  double acosVal = (velocity*velocity + distRemSq - oldDistRemSq)/(2*velocity*distanceRemaining);
                  if(acosVal < -1)
                     acosVal = -1;
                  else if(acosVal > 1)
                     acosVal = 1;
                  theta =  Math.PI - FastTrig.acos(acosVal);
                  if(theta > Math.PI/2){//in case of overshoot
                     theta = Math.PI - theta;  
                     velocity = -velocity;
                     offsetSign = -offsetSign;
                     status.finalHeading += Math.PI;
                     waveOffset = Math.PI - waveOffset;
                     waveOffsetSign = -waveOffsetSign;
                     
                  }
               }
            }
            
            if(velocity > 0.01 || velocity < -0.01){
               
               double newWaveDSq = (velocity*velocity + waveCenterDist*waveCenterDist -
                     2*velocity*waveCenterDist*FastTrig.cos(waveOffset));
               double newWaveD = Math.sqrt(newWaveDSq);
               
               
               double acosVal =  (waveCenterDist*waveCenterDist 
                     - velocity*velocity - newWaveDSq)/(2*velocity*newWaveD);
               
               if(acosVal < -1)
                  acosVal = -1;
               else if(acosVal > 1)
                  acosVal = 1;
            
               
               double newWaveOffset = FastTrig.acos(acosVal);
              
               double alpha = newWaveOffset - waveOffset;
                   
               waveBearing += alpha*waveOffsetSign;
            		
            		
               waveOffset = newWaveOffset;
               waveCenterDist = newWaveD;
            }
            
            
            time++;
            	
         }while(wave.bulletVelocity*(time + 1 - wave.fireTime) < waveCenterDist
            && !(distanceRemaining == 0.0 && velocity == 0));
         
         time = (long)(waveCenterDist/wave.bulletVelocity) + wave.fireTime - 1;
      
         
         Point2D.Double endPoint = project(wave.fireLocation, waveBearing, -waveCenterDist);
         
         return endPoint;
      }  
    
   
      // CREDIT: from CassiusClay, by PEZ
      //   - returns point length away from sourceLocation, at angle
      // robowiki.net?CassiusClay
       public static Point2D.Double project(Point2D.Double sourceLocation, double angle, double length) {
         return new Point2D.Double(sourceLocation.x + FastTrig.sin(angle) * length,
               sourceLocation.y + FastTrig.cos(angle) * length);
      }
      
      // got this from RaikoMicro, by Jamougha, but I think it's used by many authors
      //  - returns the absolute angle (in radians) from source to target points
       public static double absoluteBearing(Point2D.Double source, Point2D.Double target) {
         return FastTrig.atan2(target.x - source.x, target.y - source.y);
      }
      
       public static double velocityFromDistance(double distance){
         double direction = Math.signum(distance);
         distance = Math.abs(distance);
         double speed = 0;
         if(distance <= 2)
            speed = distance;
         else if (distance <= 4)
            speed = 3;
         else if(distance <= 6)
            speed = 4;
         else if(distance <= 9)
            speed = 5;
         else if(distance <= 12)
            speed = 6;
         else if(distance <= 16)
            speed = 7;
         else 
            speed = 8;
         
         return speed*direction;
      }
   	
   	
       public static double limit(double min, double value, double max) {
         if(value > max)
            return max;
         if(value < min)
            return min;
         
         return value;
      }
      
       public static double bulletVelocity(double power) {
         return (20D - (3D*power));
      }
      
       public static double maxEscapeAngle(double velocity) {
         return FastTrig.asin(8.0/velocity);
      }
      
       static double rollingAverage(double value, double newEntry, double depth, double weighting ) {
         return (value * depth + newEntry * weighting)/(depth + weighting);
      } 
   
       public static int getIndex(double[] slices, double value){
         int index = 0;
         while(index < slices.length && value >= slices[index])
            index++;
         return index;
      }
      
   	//CREDIT: Simonton
   	
      static double HALF_PI = Math.PI / 2;
      static double WALL_MARGIN = 18;
      static double S = WALL_MARGIN;
      static double W = WALL_MARGIN;
      static double N = 600 - WALL_MARGIN;
      static double E = 800 - WALL_MARGIN;
   
    // eDist  = the distance from you to the enemy
    // eAngle = the absolute angle from you to the enemy
    // oDir   =  1 for the clockwise orbit distance
    //          -1 for the counter-clockwise orbit distance
    // returns: the positive orbital distance (in radians) the enemy can travel
    //          before hitting a wall (possibly infinity).
       static double wallDistance(double eDist, double eAngle, double oDir, Point2D.Double fireLocation) {
       
         return Math.min(Math.min(Math.min(
            distanceWest(N - fireLocation.y, eDist, eAngle - HALF_PI, oDir),
            distanceWest(E - fireLocation.x, eDist, eAngle + Math.PI, oDir)),
            distanceWest(fireLocation.y - S, eDist, eAngle + HALF_PI, oDir)),
            distanceWest(fireLocation.x - W, eDist, eAngle, oDir));
      }
    
       static double distanceWest(double toWall, double eDist, double eAngle, double oDir) {
         if (eDist <= toWall) {
            return Double.POSITIVE_INFINITY;
         }
         double wallAngle = FastTrig.acos(-oDir * toWall / eDist) + oDir * HALF_PI;
         return Utils.normalAbsoluteAngle(oDir * (wallAngle - eAngle));
      }
      
   
      
       static double decelDistance(double vel){
      
         int intVel = (int)Math.ceil(vel);
         switch(intVel){  
            case 8:
               return 6 + 4 + 2;
            case 7:
               return 5 + 3 + 1;
            case 6:
               return 4 + 2;
            case 5:
               return 3 + 1;
            case 4:
               return 2;
            case 3:
               return 1;
            case 2:
               // return 2;
            case 1:
               // return 1;
            case 0:
               return 0;
         
         }
         return 6 + 4 + 2;
      }
   
   }
