   package jk.melee;
  
   import robocode.*;
   import java.util.*;
   import java.io.*;
    public class Neuromancer extends AdvancedRobot{
   
      MeleeSurf move;
      MeleeRadar radar;
      MeleeGun gun;
   
      static int[] finishes;
   
       public void run(){
         if(finishes == null)
            finishes = new int[getOthers()+1];
         setAdjustRadarForGunTurn(true);
         setAdjustRadarForRobotTurn(true);
         setAdjustGunForRobotTurn(true);
      
         try{
            move = new MeleeSurf(this);
         }
             catch(Exception ex){contain(ex);}
         try{
            radar = new MeleeRadar(this);
         }
             catch(Exception ex){contain(ex);}
         try{
            gun = new MeleeGun(this);
         }
             catch(Exception ex){contain(ex);}
      
         while(true){
            try{
               move.onTick();
               radar.onTick();
               gun.onTick();
               execute();
            }
                catch(Exception ex){contain(ex);}
         }
      }
   
       public void onScannedRobot(ScannedRobotEvent e){
         try{
            move.onScannedRobot(e);
            radar.onScannedRobot(e);
            gun.onScannedRobot(e);
         }
             catch(Exception ex){contain(ex);}
      }
       public void onRobotDeath(RobotDeathEvent e){
         try{
            move.onRobotDeath(e);
            radar.onRobotDeath(e);
            gun.onRobotDeath(e);
         }
             catch(Exception ex){contain(ex);}
         
      }
       public void onHitByBullet(HitByBulletEvent e){
         try{
            move.onHitByBullet(e);
         }
             catch(Exception ex){contain(ex);}
      }
       public void onBulletHitBullet(BulletHitBulletEvent e){
         try{  move.onBulletHitBullet(e);
         }
             catch(Exception ex){contain(ex);}
      }
       public void onBulletHit(BulletHitEvent e){
         try{ move.onBulletHit(e);
         }
             catch(Exception ex){contain(ex);}
      }
       public void onPaint(java.awt.Graphics2D g){
         move.onPaint(g);
         gun.onPaint(g);
      }
       public void onDeath(DeathEvent e){
         try{ gun.onDeath(e);
            finishes[getOthers()]++;
            System.out.println("Finishes: " + Arrays.toString(finishes));
         }
             catch(Exception ex){contain(ex);}
      }
       public void onWin(WinEvent e){
         try{
            gun.onWin(e);
            finishes[0]++;
            System.out.println("Finishes: " + Arrays.toString(finishes));
         }
             catch(Exception ex){contain(ex);}
      }
   
       public void contain(Exception e){
      
         e.printStackTrace();
            
         try{
            PrintStream out = new PrintStream(new RobocodeFileOutputStream(getDataFile((int)(Math.random()*1000) + ".error")));
            e.printStackTrace(out);
            out.flush();
            out.close();
         }
             catch (IOException ioex){}
      }
   
   
   }