package sp.Minis;
import robocode.*;
import robocode.util.Utils;
import java.util.ArrayList;
import java.awt.Color;

// API help : http://robocode.sourceforge.net/docs/robocode/robocode/Robot.html

/**
 * LukeUberPwnr - a robot by (your name here)
 */
public class geneticBot extends AdvancedRobot{

	static ArrayList<moveStrategy> mSArray = new ArrayList<moveStrategy>();
	static boolean hasMadeStrategies = false;
	int strategyNum = 35;
	int currentStrategyNum = 0;
	int refineNumber = 1;
	static moveStrategy currentMove;
	double firePower = 3;
	int shotCounter = 1;
	ScannedRobotEvent eScan;
	public void run() {
		setAdjustGunForRobotTurn(true);
		setAdjustRadarForGunTurn(true);
		Color darkGreen = new Color(0, 100, 0);
		Color lightGreen = new Color(0, 255, 0);
		setColors(darkGreen, darkGreen, darkGreen);
		setScanColor(darkGreen);
		setBulletColor(lightGreen);
		while(true) {
			// Replace the next 4 lines with any behavior you would like
			if (hasMadeStrategies == false) {
				makeStrategies();
				hasMadeStrategies = true;
			}
			turnRadarRightRadians(Math.PI * 2);
		}
	}

	public void makeStrategies() {
		for (int i = 0; i < strategyNum; i++) {
			mSArray.add(new moveStrategy());
		}
	}
	public void makeSpecializedStrategies(moveStrategy m) {
		for (int i = 0; i < strategyNum; i++) {
			mSArray.add(new moveStrategy(m));
		}
	}
	/**
	 * onScannedRobot: What to do when you see another robot
	 */
	public void onScannedRobot(ScannedRobotEvent e) {
		eScan = e;
		double radarTurn = Utils.normalRelativeAngle(e.getBearingRadians() + getHeadingRadians() - getRadarHeadingRadians());
		setTurnRadarRightRadians(radarTurn * 2);
		if (mSArray.size() == 0) {
			makeSpecializedStrategies(currentMove);
			refineNumber++;
		}
		if (getTurnRemaining() == 0 && getDistanceRemaining() == 0) {
			currentStrategyNum++;			
			if (currentStrategyNum >= mSArray.size() - 1) {
				currentStrategyNum = 0;
			}
			mSArray.get(currentStrategyNum).execute();
			currentMove = mSArray.get(currentStrategyNum);
		}
		firePower = 1000 / e.getDistance();
		double gunTurn = Utils.normalRelativeAngle(getHeadingRadians() + e.getBearingRadians() - getGunHeadingRadians());
		setTurnGunRightRadians((getPredictiveShotAngle(e) / shotCounter) + gunTurn);
		if (getGunHeat() == 0) {
			setFire(firePower);
			shotCounter++;
			if (shotCounter > 5) {
				shotCounter = 1;
			}
		}
	}

	public double getPredictiveShotAngle(ScannedRobotEvent e) {
		double bVel = 20 - 3 * firePower;
		double absoluteBearing = getHeadingRadians() + e.getBearingRadians();
		double gunTurn = Utils.normalRelativeAngle(e.getVelocity() * Math.sin(e.getHeadingRadians() - absoluteBearing) / bVel);
		return (gunTurn);
	}

	public void onHitByBullet(HitByBulletEvent e) {
		mSArray.remove(currentMove);
	}

	public class moveStrategy {
		double aheadAmount;
		double turnAmount;
		public moveStrategy() {
			aheadAmount = (Math.random() - 0.5) * 500;
			turnAmount = Math.toRadians((Math.random() - 0.5) * 100);
		}

		public moveStrategy(moveStrategy m) {
			double randomNum = 1 + (Math.random() - 0.5) / refineNumber;
			aheadAmount = m.getAheadAmount() * randomNum;
			turnAmount = m.getTurnAmount() * randomNum;
		}

		public double getAheadAmount() {
			return aheadAmount;
		}

		public double getTurnAmount() {
			return turnAmount;
		}
		
		public void execute() {
			out.println("turnamount = " + turnAmount);
			setTurnRightRadians(eScan.getBearingRadians() + (Math.PI / 2) + turnAmount);
			setAhead(aheadAmount);
		}
	}
}