package tjk;

import robocode.*;
import robocode.util.Utils;
import tjk.universe.Universe;
import tjk.offense.Gun;
import tjk.defense.Wheels;
import tjk.utils.tjkUtil;
import java.awt.Color;
import java.awt.Graphics2D;

/**
 * DeBroglie - a robot by tkiesel
 */
public class deBroglie extends AdvancedRobot
{
	
	private static Universe universe;
	private static Gun gun;
	private static Wheels wheels;
	//private Sword sword = new Sword(universe);
	
	/**
	 * run: DeBroglie's default behavior
	 */
	public void run() {
		
		setAdjustGunForRobotTurn(true);
		setAdjustRadarForRobotTurn(true);
		setAdjustRadarForGunTurn(true);
		
		setColors(new Color(148,95,38), new Color(186,127,59), new Color(223,173,112), Color.WHITE, new Color(206,182,146));
		if ( getRoundNum() == 0 ) {
			universe = new Universe(this);
			universe.init();
			tjkUtil.init();
			gun = new Gun(this,universe);
			wheels = new Wheels(this);
		}
		turnRadarRightRadians(Double.POSITIVE_INFINITY);
		
	}

	/**
	 * onScannedRobot: What to do when you see another robot
	 */
	public void onScannedRobot(ScannedRobotEvent e) {
	    universe.update(e);
		gun.onScannedRobot(e);
		wheels.onScannedRobot(e);
		double radarTurn = getHeadingRadians() + e.getBearingRadians() - getRadarHeadingRadians();
 		setTurnRadarRightRadians(1.95*Utils.normalRelativeAngle(radarTurn));
	}

	/**
	 * onHitByBullet: What to do when you're hit by a bullet
	 */
	public void onHitByBullet(HitByBulletEvent e) {
		wheels.onHitByBullet(e);
	}
	
	/**
	 * onHitWall: What to do when you hit a wall
	 */
	public void onHitWall(HitWallEvent e) {
	}

	public void onDeath(DeathEvent e)
	{
		universe.onDeath(e);
	}

	public void onWin(WinEvent e)
	{
		universe.onWin(e);
	}

	public void onRoundEnded(RoundEndedEvent e)
	{
		universe.onRoundEnded(e);
	}

	public void onPaint(Graphics2D g)
	{
		universe.paint(g);
		gun.paint(g);
	}

}
