package tjk.universe;

import tjk.utils.KdTree.*;
import java.util.List;
/**
 * WaveStats - a class by tkiesel
 */
public class WaveStats
{
	
	private WeightedSqrEuclid<GFBracket> stats;
	
	public WaveStats()
	{
		stats = new WeightedSqrEuclid<GFBracket>(Segmentation.DIMENSIONS,new Integer(Segmentation.STATS_BUFFER));
		stats.setWeights(Segmentation.WEIGHTS);
	}
	
	public void addWave(Wave w)
	{
		stats.addPoint(w.getSituation(), new GFBracket(w.getHitBracket()));
	}

	public BracketHist getBracketHist(Wave w, int closestK)
	{
		List<Entry<GFBracket>> entry = stats.nearestNeighbor(w.getSituation(), closestK, false);
		if ( entry.size() <=0 )
		{
			System.out.println("ERROR: The kdTree returned an empty nearestNeighbor!");
		}
		return new BracketHist(entry);
	}	
	
	public int getSize()
	{
		return stats.size();
	}
	
}