package xander.cat.group.mirror;

import xander.core.ComponentChain;
import xander.core.Resources;
import xander.core.drive.Drive;
import xander.core.drive.OrbitalDrivePredictor;
import xander.core.gun.Gun;
import xander.core.gun.XanderGun;
import xander.core.gun.power.FixedPowerSelector;
import xander.core.gun.power.PowerSelector;

public class MirrorFactory {

	public static void addAntiMirrorComponents(ComponentChain componentChain, int scanDepth) {
		MirrorPlan mirrorPlan = new MirrorPlan(Resources.getRobotEvents());
		OrbitalDrivePredictor orbitalDrivePredictor = new OrbitalDrivePredictor();
		MirrorScenario mirrorScenario = new MirrorScenario(scanDepth);
		Drive antiMirrorDrive = new AntiMirrorDrive(mirrorPlan, orbitalDrivePredictor);
		PowerSelector powerSelector = new FixedPowerSelector(1.95);
		((FixedPowerSelector)powerSelector).setAllowAutoAdjust(false);
		AntiMirrorTargeter targeter = new AntiMirrorTargeter(mirrorPlan, orbitalDrivePredictor);
		Gun antiMirrorGun = new XanderGun(targeter, powerSelector);
		componentChain.addComponents(mirrorScenario, antiMirrorDrive, antiMirrorGun);
	}
}
