package xander.gfws.segment;

import xander.core.log.Logger;
import xander.core.math.RCPhysics;
import xander.core.track.Wave;

public class DefenderSpeedSegmenter extends AbstractSegmenter {

	public DefenderSpeedSegmenter(int numSegments) {
		super(numSegments, 0, RCPhysics.MAX_SPEED);
	}
	
	@Override
	public String getName() {
		return "Defender Speed";
	}

	@Override
	public double getSegmentValue(Wave wave) {
		return Math.abs(wave.getInitialDefenderSnapshot().getVelocity());
	}

	@Override
	protected String getDescriptionForRange(int segmentIndex, double rangeStart, double rangeStop) {
		return "Defender speed from " + Logger.format(rangeStart) + " to " + Logger.format(rangeStop);
	}
}
